/**
 * Generated by Apache Royale Compiler from org/apache/royale/crux/controller/AbstractController.as
 * org.apache.royale.crux.controller.AbstractController
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.crux.controller.AbstractController');

goog.require('mx.rpc.AsyncToken');
goog.require('org.apache.royale.crux.ICrux');
goog.require('org.apache.royale.crux.utils.chain.AsyncCommandChainStep');
goog.require('org.apache.royale.crux.utils.chain.ChainType');
goog.require('org.apache.royale.crux.utils.chain.CommandChain');
goog.require('org.apache.royale.crux.utils.services.CruxResponder');
goog.require('org.apache.royale.crux.utils.services.CruxURLRequest');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.net.URLLoader');
goog.require('org.apache.royale.net.URLRequest');
goog.require('org.apache.royale.crux.ICruxAware');
goog.require('org.apache.royale.crux.IDispatcherAware');



/**
 * @constructor
 * @implements {org.apache.royale.crux.ICruxAware}
 * @implements {org.apache.royale.crux.IDispatcherAware}
 */
org.apache.royale.crux.controller.AbstractController = function() {
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.crux.controller.AbstractController', org.apache.royale.crux.controller.AbstractController);


/**
 * @export
 * @type {org.apache.royale.crux.ICrux}
 */
org.apache.royale.crux.controller.AbstractController.prototype._crux;


/**
 * @private
 * @type {org.apache.royale.events.IEventDispatcher}
 */
org.apache.royale.crux.controller.AbstractController.prototype.org_apache_royale_crux_controller_AbstractController__dispatcher;


/** Delegates execute service call to Crux 
 * @protected
 * @param {mx.rpc.AsyncToken} call
 * @param {Function} resultHandler
 * @param {Function=} faultHandler
 * @param {Array=} handlerArgs
 * @return {mx.rpc.AsyncToken}
 */
org.apache.royale.crux.controller.AbstractController.prototype.executeServiceCall = function(call, resultHandler, faultHandler, handlerArgs) {
  faultHandler = typeof faultHandler !== 'undefined' ? faultHandler : null;
  handlerArgs = typeof handlerArgs !== 'undefined' ? handlerArgs : null;
  if (faultHandler == null && this._crux.config.defaultFaultHandler != null)
    faultHandler = this._crux.config.defaultFaultHandler;
  call.addResponder(new org.apache.royale.crux.utils.services.CruxResponder(resultHandler, faultHandler, handlerArgs));
  return call;
};


/** Delegates execute url request call to Crux 
 * @protected
 * @param {org.apache.royale.net.URLRequest} request
 * @param {Function} resultHandler
 * @param {Function=} faultHandler
 * @param {Function=} progressHandler
 * @param {Function=} httpStatusHandler
 * @param {Array=} handlerArgs
 * @return {org.apache.royale.net.URLLoader}
 */
org.apache.royale.crux.controller.AbstractController.prototype.executeURLRequest = function(request, resultHandler, faultHandler, progressHandler, httpStatusHandler, handlerArgs) {
  faultHandler = typeof faultHandler !== 'undefined' ? faultHandler : null;
  progressHandler = typeof progressHandler !== 'undefined' ? progressHandler : null;
  httpStatusHandler = typeof httpStatusHandler !== 'undefined' ? httpStatusHandler : null;
  handlerArgs = typeof handlerArgs !== 'undefined' ? handlerArgs : null;
  if (faultHandler == null && this._crux.config.defaultFaultHandler != null)
    faultHandler = this._crux.config.defaultFaultHandler;
  return new org.apache.royale.crux.utils.services.CruxURLRequest(request, resultHandler, faultHandler, progressHandler, httpStatusHandler, handlerArgs).loader;
};


/** Delegates create command to Crux 
 * @protected
 * @param {Function} delayedCall
 * @param {Array} args
 * @param {Function} resultHandler
 * @param {Function=} faultHandler
 * @param {Array=} handlerArgs
 * @return {org.apache.royale.crux.utils.chain.AsyncCommandChainStep}
 */
org.apache.royale.crux.controller.AbstractController.prototype.createCommand = function(delayedCall, args, resultHandler, faultHandler, handlerArgs) {
  faultHandler = typeof faultHandler !== 'undefined' ? faultHandler : null;
  handlerArgs = typeof handlerArgs !== 'undefined' ? handlerArgs : null;
  return new org.apache.royale.crux.utils.chain.AsyncCommandChainStep(delayedCall, args, resultHandler, faultHandler, handlerArgs);
};


/** Constructs a dynamic command 
 * @export
 * @param {string=} mode
 * @return {org.apache.royale.crux.utils.chain.CommandChain}
 */
org.apache.royale.crux.controller.AbstractController.prototype.createChain = function(mode) {
  mode = typeof mode !== 'undefined' ? mode : org.apache.royale.crux.utils.chain.ChainType.SEQUENCE;
  return new org.apache.royale.crux.utils.chain.CommandChain(mode);
};


org.apache.royale.crux.controller.AbstractController.prototype.set__crux = function(crux) {
  this._crux = crux;
};


org.apache.royale.crux.controller.AbstractController.prototype.get__dispatcher = function() {
  return this.org_apache_royale_crux_controller_AbstractController__dispatcher;
};


org.apache.royale.crux.controller.AbstractController.prototype.set__dispatcher = function(dispatcher) {
  this.org_apache_royale_crux_controller_AbstractController__dispatcher = dispatcher;
};


Object.defineProperties(org.apache.royale.crux.controller.AbstractController.prototype, /** @lends {org.apache.royale.crux.controller.AbstractController.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.crux.ICrux} */
crux: {
set: org.apache.royale.crux.controller.AbstractController.prototype.set__crux},
/**
  * @export
  * @type {org.apache.royale.events.IEventDispatcher} */
dispatcher: {
get: org.apache.royale.crux.controller.AbstractController.prototype.get__dispatcher,
set: org.apache.royale.crux.controller.AbstractController.prototype.set__dispatcher}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.crux.controller.AbstractController.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AbstractController', qName: 'org.apache.royale.crux.controller.AbstractController', kind: 'class' }], interfaces: [org.apache.royale.crux.ICruxAware, org.apache.royale.crux.IDispatcherAware] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.crux.controller.AbstractController.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        '_crux': { type: 'org.apache.royale.crux.ICrux', get_set: function (/** org.apache.royale.crux.controller.AbstractController */ inst, /** * */ v) {return v !== undefined ? inst._crux = v : inst._crux;}}
      };
    },
    accessors: function () {
      return {
        'crux': { type: 'org.apache.royale.crux.ICrux', access: 'writeonly', declaredBy: 'org.apache.royale.crux.controller.AbstractController'},
        'dispatcher': { type: 'org.apache.royale.events.IEventDispatcher', access: 'readwrite', declaredBy: 'org.apache.royale.crux.controller.AbstractController'}
      };
    },
    methods: function () {
      return {
        'AbstractController': { type: '', declaredBy: 'org.apache.royale.crux.controller.AbstractController'},
        'createChain': { type: 'org.apache.royale.crux.utils.chain.CommandChain', declaredBy: 'org.apache.royale.crux.controller.AbstractController', parameters: function () { return [ { index: 1, type: 'String', optional: true } ]; }}
      };
    }
  };
};
/**
 * @export
 * @const
 * @type {number}
 */
org.apache.royale.crux.controller.AbstractController.prototype.ROYALE_REFLECTION_INFO.compileFlags = 10;