/**
 * Generated by Apache Royale Compiler from org/apache/royale/crux/utils/chain/AbstractChain.as
 * org.apache.royale.crux.utils.chain.AbstractChain
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.crux.utils.chain.AbstractChain');

goog.require('org.apache.royale.crux.events.ChainEvent');
goog.require('org.apache.royale.crux.utils.chain.ChainType');
goog.require('org.apache.royale.crux.utils.chain.IChain');
goog.require('org.apache.royale.crux.utils.chain.IChainStep');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {org.apache.royale.crux.utils.chain.IChainStep}
 * @param {string=} mode
 * @param {boolean=} stopOnError
 */
org.apache.royale.crux.utils.chain.AbstractChain = function(mode, stopOnError) {
  org.apache.royale.crux.utils.chain.AbstractChain.base(this, 'constructor');
  mode = typeof mode !== 'undefined' ? mode : org.apache.royale.crux.utils.chain.ChainType.SEQUENCE;
  stopOnError = typeof stopOnError !== 'undefined' ? stopOnError : true;
  
  this.mode = org.apache.royale.crux.utils.chain.ChainType.SEQUENCE;
  this.steps = [];
  this.mode = mode;
  this.stopOnError = stopOnError;
};
goog.inherits(org.apache.royale.crux.utils.chain.AbstractChain, org.apache.royale.events.EventDispatcher);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.crux.utils.chain.AbstractChain', org.apache.royale.crux.utils.chain.AbstractChain);


/**
 * @export
 * @type {string}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.mode;


/**
 * @export
 * @type {Array}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.steps;


/**
 * @protected
 * @type {org.apache.royale.crux.utils.chain.IChain}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype._chain;


/**
 * @protected
 * @type {boolean}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype._isComplete = true;


/**
 * @protected
 * @type {boolean}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype._isError = false;


/**
 * @protected
 * @type {number}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype._position = -1;


/**
 * @protected
 * @type {boolean}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype._stopOnError;


/**
 *
 * @export
 * @param {org.apache.royale.crux.utils.chain.IChainStep} step
 * @return {org.apache.royale.crux.utils.chain.IChain}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.addStep = function(step) {
  step.chain = org.apache.royale.utils.Language.as(this, org.apache.royale.crux.utils.chain.IChain, true);
  this.steps.push(step);
  return org.apache.royale.utils.Language.as(this, org.apache.royale.crux.utils.chain.IChain, true);
};


/**
 *
 * @export
 * @return {boolean}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.hasNext = function() {
  return this.position + 1 < this.steps.length;
};


/**
 *
 * @export
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.start = function() {
  if (this._isComplete) {
    this._isComplete = false;
    this._isError = false;
    this.position = -1;
    this.proceed();
  }
};


/**
 * @export
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.stepComplete = function() {
  this.dispatchEvent(new org.apache.royale.crux.events.ChainEvent(org.apache.royale.crux.events.ChainEvent.CHAIN_STEP_COMPLETE));
  if (this.mode == org.apache.royale.crux.utils.chain.ChainType.SEQUENCE) {
    this.proceed();
  } else {
    for (var /** @type {number} */ i = 0; i < this.steps.length; i++) {
      if (!org.apache.royale.utils.Language.as(this.steps[i], org.apache.royale.crux.utils.chain.IChainStep, true).isComplete)
        return;
    }
    this.complete();
  }
};


/**
 *
 * @export
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.proceed = function() {
  if (this.position == -1)
    this.dispatchEvent(new org.apache.royale.crux.events.ChainEvent(org.apache.royale.crux.events.ChainEvent.CHAIN_START));
  if (!this._isError) {
    if (this.mode == org.apache.royale.crux.utils.chain.ChainType.SEQUENCE) {
      if (this.hasNext()) {
        this.position++;
        org.apache.royale.utils.Language.as(this, org.apache.royale.crux.utils.chain.IChain, true).doProceed();
      } else {
        this.complete();
      }
    } else {
      for (var /** @type {number} */ i = 0; i < this.steps.length; i++) {
        this.position = i;
        org.apache.royale.utils.Language.as(this, org.apache.royale.crux.utils.chain.IChain, true).doProceed();
      }
    }
  }
};


/**
 *
 * @export
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.stepError = function() {
  this.dispatchEvent(new org.apache.royale.crux.events.ChainEvent(org.apache.royale.crux.events.ChainEvent.CHAIN_STEP_ERROR));
  if (!this.stopOnError)
    this.proceed();
  else
    this.fail();
};


/**
 *
 * @export
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.complete = function() {
  this.dispatchEvent(new org.apache.royale.crux.events.ChainEvent(org.apache.royale.crux.events.ChainEvent.CHAIN_COMPLETE));
  this._isComplete = true;
  if (this.chain != null)
    this.chain.stepComplete();
};


/**
 *
 * @export
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.error = function() {
  this.fail();
};


/**
 *
 * @protected
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.fail = function() {
  this.dispatchEvent(new org.apache.royale.crux.events.ChainEvent(org.apache.royale.crux.events.ChainEvent.CHAIN_FAIL));
  this._isError = true;
  this._isComplete = true;
  if (this.chain != null)
    this.chain.stepError();
};


org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__currentStep = function() {
  return org.apache.royale.utils.Language.as(this.steps[this.position], org.apache.royale.crux.utils.chain.IChainStep, true);
};


org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__chain = function() {
  return this._chain;
};


org.apache.royale.crux.utils.chain.AbstractChain.prototype.set__chain = function(value) {
  this._chain = value;
};


org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__isComplete = function() {
  return this._isComplete;
};


org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__isError = function() {
  return this._isError;
};


org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__position = function() {
  return this._position;
};


org.apache.royale.crux.utils.chain.AbstractChain.prototype.set__position = function(value) {
  this._position = value;
};


org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__stopOnError = function() {
  return this._stopOnError;
};


org.apache.royale.crux.utils.chain.AbstractChain.prototype.set__stopOnError = function(value) {
  this._stopOnError = value;
};


Object.defineProperties(org.apache.royale.crux.utils.chain.AbstractChain.prototype, /** @lends {org.apache.royale.crux.utils.chain.AbstractChain.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.crux.utils.chain.IChainStep} */
currentStep: {
get: org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__currentStep},
/**
  * @export
  * @type {org.apache.royale.crux.utils.chain.IChain} */
chain: {
get: org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__chain,
set: org.apache.royale.crux.utils.chain.AbstractChain.prototype.set__chain},
/**
  * @export
  * @type {boolean} */
isComplete: {
get: org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__isComplete},
/**
  * @export
  * @type {boolean} */
isError: {
get: org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__isError},
/**
  * @export
  * @type {number} */
position: {
get: org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__position,
set: org.apache.royale.crux.utils.chain.AbstractChain.prototype.set__position},
/**
  * @export
  * @type {boolean} */
stopOnError: {
get: org.apache.royale.crux.utils.chain.AbstractChain.prototype.get__stopOnError,
set: org.apache.royale.crux.utils.chain.AbstractChain.prototype.set__stopOnError}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AbstractChain', qName: 'org.apache.royale.crux.utils.chain.AbstractChain', kind: 'class' }], interfaces: [org.apache.royale.crux.utils.chain.IChainStep] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'mode': { type: 'String', get_set: function (/** org.apache.royale.crux.utils.chain.AbstractChain */ inst, /** * */ v) {return v !== undefined ? inst.mode = v : inst.mode;}},
        'steps': { type: 'Array', get_set: function (/** org.apache.royale.crux.utils.chain.AbstractChain */ inst, /** * */ v) {return v !== undefined ? inst.steps = v : inst.steps;}}
      };
    },
    accessors: function () {
      return {
        'currentStep': { type: 'org.apache.royale.crux.utils.chain.IChainStep', access: 'readonly', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'},
        'chain': { type: 'org.apache.royale.crux.utils.chain.IChain', access: 'readwrite', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'},
        'isComplete': { type: 'Boolean', access: 'readonly', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'},
        'isError': { type: 'Boolean', access: 'readonly', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'},
        'position': { type: 'int', access: 'readwrite', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'},
        'stopOnError': { type: 'Boolean', access: 'readwrite', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'}
      };
    },
    methods: function () {
      return {
        'AbstractChain': { type: '', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain', parameters: function () { return [ { index: 1, type: 'String', optional: true },{ index: 2, type: 'Boolean', optional: true } ]; }},
        'addStep': { type: 'org.apache.royale.crux.utils.chain.IChain', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain', parameters: function () { return [ { index: 1, type: 'org.apache.royale.crux.utils.chain.IChainStep', optional: false } ]; }},
        'hasNext': { type: 'Boolean', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'},
        'start': { type: 'void', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'},
        'stepComplete': { type: 'void', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'},
        'proceed': { type: 'void', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'},
        'stepError': { type: 'void', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'},
        'complete': { type: 'void', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'},
        'error': { type: 'void', declaredBy: 'org.apache.royale.crux.utils.chain.AbstractChain'}
      };
    }
  };
};
/**
 * @export
 * @const
 * @type {number}
 */
org.apache.royale.crux.utils.chain.AbstractChain.prototype.ROYALE_REFLECTION_INFO.compileFlags = 10;