/**
 * Generated by Apache Royale Compiler from org/apache/royale/crux/utils/chain/AsyncCommandChainStep.as
 * org.apache.royale.crux.utils.chain.AsyncCommandChainStep
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.crux.utils.chain.AsyncCommandChainStep');

goog.require('mx.rpc.AsyncToken');
goog.require('org.apache.royale.crux.utils.chain.CommandChainStep');
goog.require('mx.rpc.IResponder');



/**
 * @constructor
 * @extends {org.apache.royale.crux.utils.chain.CommandChainStep}
 * @implements {mx.rpc.IResponder}
 * @param {Function} asyncMethod
 * @param {Array=} asyncMethodArgs
 * @param {Function=} resultHandler
 * @param {Function=} faultHandler
 * @param {Array=} handlerArgs
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep = function(asyncMethod, asyncMethodArgs, resultHandler, faultHandler, handlerArgs) {
  org.apache.royale.crux.utils.chain.AsyncCommandChainStep.base(this, 'constructor');
  asyncMethodArgs = typeof asyncMethodArgs !== 'undefined' ? asyncMethodArgs : null;
  resultHandler = typeof resultHandler !== 'undefined' ? resultHandler : null;
  faultHandler = typeof faultHandler !== 'undefined' ? faultHandler : null;
  handlerArgs = typeof handlerArgs !== 'undefined' ? handlerArgs : null;
  this.asyncMethodArgs = asyncMethodArgs;
  this.asyncMethod = asyncMethod;
  this.resultHandler = resultHandler;
  this.faultHandler = faultHandler;
  this.handlerArgs = handlerArgs;
};
goog.inherits(org.apache.royale.crux.utils.chain.AsyncCommandChainStep, org.apache.royale.crux.utils.chain.CommandChainStep);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.crux.utils.chain.AsyncCommandChainStep', org.apache.royale.crux.utils.chain.AsyncCommandChainStep);


/**
 * @protected
 * @type {Function}
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.asyncMethod;


/**
 * @protected
 * @type {Array}
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.asyncMethodArgs;


/**
 * @protected
 * @type {Function}
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.resultHandler;


/**
 * @protected
 * @type {Function}
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.faultHandler;


/**
 * @protected
 * @type {Array}
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.handlerArgs;


/**
 * @export
 * @override
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.execute = function() {
  var /** @type {mx.rpc.AsyncToken} */ token;
  if (this.asyncMethodArgs != null)
    token = this.asyncMethod.apply(null, this.asyncMethodArgs);
  else
    token = this.asyncMethod();
  token.addResponder(this);
};


/**
 * @export
 * @override
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.doProceed = function() {
  this.execute();
};


/**
 *
 * @export
 * @param {Object} data
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.result = function(data) {
  if (this.resultHandler != null) {
    if (this.handlerArgs == null) {
      this.resultHandler(data);
    } else {
      this.resultHandler.apply(this, [data].concat(this.handlerArgs));
    }
  }
  this.complete();
};


/**
 *
 * @export
 * @param {Object} info
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.fault = function(info) {
  if (this.faultHandler != null) {
    if (this.handlerArgs == null) {
      this.faultHandler(info);
    } else {
      try {
        this.faultHandler(info);
      } catch (e) {
        this.faultHandler.apply(null, [info].concat(this.handlerArgs));
      }
    }
  }
  this.error();
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AsyncCommandChainStep', qName: 'org.apache.royale.crux.utils.chain.AsyncCommandChainStep', kind: 'class' }], interfaces: [mx.rpc.IResponder] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {return {};},
    methods: function () {
      return {
        'AsyncCommandChainStep': { type: '', declaredBy: 'org.apache.royale.crux.utils.chain.AsyncCommandChainStep', parameters: function () { return [ { index: 1, type: 'Function', optional: false },{ index: 2, type: 'Array', optional: true },{ index: 3, type: 'Function', optional: true },{ index: 4, type: 'Function', optional: true },{ index: 5, type: 'Array', optional: true } ]; }},
        'execute': { type: 'void', declaredBy: 'org.apache.royale.crux.utils.chain.AsyncCommandChainStep'},
        'doProceed': { type: 'void', declaredBy: 'org.apache.royale.crux.utils.chain.AsyncCommandChainStep'},
        'result': { type: 'void', declaredBy: 'org.apache.royale.crux.utils.chain.AsyncCommandChainStep', parameters: function () { return [ { index: 1, type: 'Object', optional: false } ]; }},
        'fault': { type: 'void', declaredBy: 'org.apache.royale.crux.utils.chain.AsyncCommandChainStep', parameters: function () { return [ { index: 1, type: 'Object', optional: false } ]; }}
      };
    }
  };
};
/**
 * @export
 * @const
 * @type {number}
 */
org.apache.royale.crux.utils.chain.AsyncCommandChainStep.prototype.ROYALE_REFLECTION_INFO.compileFlags = 10;