/**
 * Generated by Apache Royale Compiler from org/apache/royale/crux/utils/services/ChannelSetHelper.as
 * org.apache.royale.crux.utils.services.ChannelSetHelper
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.crux.utils.services.ChannelSetHelper');

goog.require('mx.messaging.Channel');
goog.require('mx.messaging.ChannelSet');
goog.require('mx.messaging.channels.AMFChannel');
goog.require('mx.messaging.channels.SecureAMFChannel');
goog.require('org.apache.royale.crux.IInitializing');



/**
 * @constructor
 * @extends {mx.messaging.ChannelSet}
 * @implements {org.apache.royale.crux.IInitializing}
 * @param {Array=} channelIds
 * @param {boolean=} clusteredWithURLLoadBalancing
 */
org.apache.royale.crux.utils.services.ChannelSetHelper = function(channelIds, clusteredWithURLLoadBalancing) {
  channelIds = typeof channelIds !== 'undefined' ? channelIds : null;
  clusteredWithURLLoadBalancing = typeof clusteredWithURLLoadBalancing !== 'undefined' ? clusteredWithURLLoadBalancing : false;
  org.apache.royale.crux.utils.services.ChannelSetHelper.base(this, 'constructor', channelIds, clusteredWithURLLoadBalancing);
};
goog.inherits(org.apache.royale.crux.utils.services.ChannelSetHelper, mx.messaging.ChannelSet);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.crux.utils.services.ChannelSetHelper', org.apache.royale.crux.utils.services.ChannelSetHelper);


/**
 * @private
 * @const
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_CHANNEL_ID = "orca-amf";


/**
 * @private
 * @const
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_PROTOCOL = "http";


/**
 * @private
 * @const
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_SERVER_NAME = "localhost";


/**
 * @private
 * @const
 * @type {number}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_SERVER_PORT = 8080;


/**
 * @private
 * @const
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_CONTEXT_ROOT = "/";


/**
 * @private
 * @const
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_ENDPOINT_NAME = "messagebroker/amf";


/**
 * @export
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.channelId;


/**
 * @export
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.protocol;


/**
 * @export
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.serverName;


/**
 * @export
 * @type {number}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.serverPort = 0;


/**
 * @export
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.contextRoot;


/**
 * @export
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.endPointName;


/**
 * @export
 * @type {Object}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.parameterSource;


/**
 * @export
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.parameterName;


/**
 * @private
 * @type {string}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.org_apache_royale_crux_utils_services_ChannelSetHelper_url;


/**
 * @private
 * @type {boolean}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.org_apache_royale_crux_utils_services_ChannelSetHelper_channelCreated = false;


/**
 * @export
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.afterPropertiesSet = function() {
  if (!this.org_apache_royale_crux_utils_services_ChannelSetHelper_channelCreated) {
    this.org_apache_royale_crux_utils_services_ChannelSetHelper_checkParameters();
    this.org_apache_royale_crux_utils_services_ChannelSetHelper_createChannel();
  }
};


/**
 * @private
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.org_apache_royale_crux_utils_services_ChannelSetHelper_checkParameters = function() {
  if (this.parameterSource != null && this.parameterName != null)
    this.org_apache_royale_crux_utils_services_ChannelSetHelper_url = org.apache.royale.utils.Language.string(this.parameterSource.parameters[this.parameterName]);
};


/**
 * Constructs the AMF Channel and adds to the channel set
 * @private
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.org_apache_royale_crux_utils_services_ChannelSetHelper_createChannel = function() {
  if (!this.org_apache_royale_crux_utils_services_ChannelSetHelper_channelCreated) {
    var /** @type {mx.messaging.Channel} */ amfChannel;
    if (this.org_apache_royale_crux_utils_services_ChannelSetHelper_PROTOCOL == "https" || this.org_apache_royale_crux_utils_services_ChannelSetHelper_AMF_ENDPOINT.indexOf("https") > -1)
      amfChannel = new mx.messaging.channels.SecureAMFChannel(this.org_apache_royale_crux_utils_services_ChannelSetHelper_CHANNEL_ID, this.org_apache_royale_crux_utils_services_ChannelSetHelper_AMF_ENDPOINT);
    else
      amfChannel = new mx.messaging.channels.AMFChannel(this.org_apache_royale_crux_utils_services_ChannelSetHelper_CHANNEL_ID, this.org_apache_royale_crux_utils_services_ChannelSetHelper_AMF_ENDPOINT);
    this.addChannel(amfChannel);
    this.org_apache_royale_crux_utils_services_ChannelSetHelper_channelCreated = true;
  }
};


org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_AMF_ENDPOINT = function() {
  if (this.org_apache_royale_crux_utils_services_ChannelSetHelper_url != null && this.org_apache_royale_crux_utils_services_ChannelSetHelper_url.length)
    return this.org_apache_royale_crux_utils_services_ChannelSetHelper_url;
  else
    return this.org_apache_royale_crux_utils_services_ChannelSetHelper_PROTOCOL + "://" + this.org_apache_royale_crux_utils_services_ChannelSetHelper_SERVER_NAME + ":" + this.org_apache_royale_crux_utils_services_ChannelSetHelper_SERVER_PORT + this.org_apache_royale_crux_utils_services_ChannelSetHelper_CONTEXT_ROOT + "/" + this.org_apache_royale_crux_utils_services_ChannelSetHelper_ENDPOINT_NAME;
};


org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_CHANNEL_ID = function() {
  return this.channelId != null ? this.channelId : org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_CHANNEL_ID;
};


org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_PROTOCOL = function() {
  return this.protocol != null ? this.protocol : org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_PROTOCOL;
};


org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_SERVER_NAME = function() {
  return this.serverName != null ? this.serverName : org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_SERVER_NAME;
};


org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_SERVER_PORT = function() {
  return this.serverPort != 0 ? this.serverPort : org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_SERVER_PORT;
};


org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_CONTEXT_ROOT = function() {
  return this.contextRoot != null ? this.contextRoot : org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_CONTEXT_ROOT;
};


org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_ENDPOINT_NAME = function() {
  return this.endPointName != null ? this.endPointName : org.apache.royale.crux.utils.services.ChannelSetHelper.DEFAULT_ENDPOINT_NAME;
};


Object.defineProperties(org.apache.royale.crux.utils.services.ChannelSetHelper.prototype, /** @lends {org.apache.royale.crux.utils.services.ChannelSetHelper.prototype} */ {
/**
  * @export
  * @type {string} */
org_apache_royale_crux_utils_services_ChannelSetHelper_AMF_ENDPOINT: {
get: org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_AMF_ENDPOINT},
/**
  * @export
  * @type {string} */
org_apache_royale_crux_utils_services_ChannelSetHelper_CHANNEL_ID: {
get: org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_CHANNEL_ID},
/**
  * @export
  * @type {string} */
org_apache_royale_crux_utils_services_ChannelSetHelper_PROTOCOL: {
get: org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_PROTOCOL},
/**
  * @export
  * @type {string} */
org_apache_royale_crux_utils_services_ChannelSetHelper_SERVER_NAME: {
get: org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_SERVER_NAME},
/**
  * @export
  * @type {number} */
org_apache_royale_crux_utils_services_ChannelSetHelper_SERVER_PORT: {
get: org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_SERVER_PORT},
/**
  * @export
  * @type {string} */
org_apache_royale_crux_utils_services_ChannelSetHelper_CONTEXT_ROOT: {
get: org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_CONTEXT_ROOT},
/**
  * @export
  * @type {string} */
org_apache_royale_crux_utils_services_ChannelSetHelper_ENDPOINT_NAME: {
get: org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.get__org_apache_royale_crux_utils_services_ChannelSetHelper_ENDPOINT_NAME}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ChannelSetHelper', qName: 'org.apache.royale.crux.utils.services.ChannelSetHelper', kind: 'class' }], interfaces: [org.apache.royale.crux.IInitializing] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'channelId': { type: 'String', get_set: function (/** org.apache.royale.crux.utils.services.ChannelSetHelper */ inst, /** * */ v) {return v !== undefined ? inst.channelId = v : inst.channelId;}},
        'protocol': { type: 'String', get_set: function (/** org.apache.royale.crux.utils.services.ChannelSetHelper */ inst, /** * */ v) {return v !== undefined ? inst.protocol = v : inst.protocol;}},
        'serverName': { type: 'String', get_set: function (/** org.apache.royale.crux.utils.services.ChannelSetHelper */ inst, /** * */ v) {return v !== undefined ? inst.serverName = v : inst.serverName;}},
        'serverPort': { type: 'int', get_set: function (/** org.apache.royale.crux.utils.services.ChannelSetHelper */ inst, /** * */ v) {return v !== undefined ? inst.serverPort = v : inst.serverPort;}},
        'contextRoot': { type: 'String', get_set: function (/** org.apache.royale.crux.utils.services.ChannelSetHelper */ inst, /** * */ v) {return v !== undefined ? inst.contextRoot = v : inst.contextRoot;}},
        'endPointName': { type: 'String', get_set: function (/** org.apache.royale.crux.utils.services.ChannelSetHelper */ inst, /** * */ v) {return v !== undefined ? inst.endPointName = v : inst.endPointName;}},
        'parameterSource': { type: 'Object', get_set: function (/** org.apache.royale.crux.utils.services.ChannelSetHelper */ inst, /** * */ v) {return v !== undefined ? inst.parameterSource = v : inst.parameterSource;}},
        'parameterName': { type: 'String', get_set: function (/** org.apache.royale.crux.utils.services.ChannelSetHelper */ inst, /** * */ v) {return v !== undefined ? inst.parameterName = v : inst.parameterName;}}
      };
    },
    accessors: function () {return {};},
    methods: function () {
      return {
        'ChannelSetHelper': { type: '', declaredBy: 'org.apache.royale.crux.utils.services.ChannelSetHelper', parameters: function () { return [ { index: 1, type: 'Array', optional: true },{ index: 2, type: 'Boolean', optional: true } ]; }},
        'afterPropertiesSet': { type: 'void', declaredBy: 'org.apache.royale.crux.utils.services.ChannelSetHelper'}
      };
    }
  };
};
/**
 * @export
 * @const
 * @type {number}
 */
org.apache.royale.crux.utils.services.ChannelSetHelper.prototype.ROYALE_REFLECTION_INFO.compileFlags = 10;