/**
 * Generated by Apache Royale Compiler from org/apache/royale/crux/utils/services/CruxURLRequest.as
 * org.apache.royale.crux.utils.services.CruxURLRequest
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.crux.utils.services.CruxURLRequest');

goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.ProgressEvent');
goog.require('org.apache.royale.net.HTTPConstants');
goog.require('org.apache.royale.net.URLLoader');
goog.require('org.apache.royale.net.URLRequest');



/**
 *
 * @asparam request
 * @asparam resultHandler The resultHandler function must expect the an event. event.currentTarget.data should contain the result. Signature can be extended with additional handlerArgs
 * @asparam faultHandler The faultHandler function will be called for IOErrors and SecurityErrors with the specific error event.
 * @asparam progressHandler
 * @asparam httpStatusHandler
 * @asparam handlerArgs The handlerArgs will be applied to the signature of the resultHandler function.
 *
 * @constructor
 * @param {org.apache.royale.net.URLRequest} request
 * @param {Function} resultHandler
 * @param {Function=} faultHandler
 * @param {Function=} progressHandler
 * @param {Function=} httpStatusHandler
 * @param {Array=} handlerArgs
 */
org.apache.royale.crux.utils.services.CruxURLRequest = function(request, resultHandler, faultHandler, progressHandler, httpStatusHandler, handlerArgs) {
  var self = this;
  faultHandler = typeof faultHandler !== 'undefined' ? faultHandler : null;
  progressHandler = typeof progressHandler !== 'undefined' ? progressHandler : null;
  httpStatusHandler = typeof httpStatusHandler !== 'undefined' ? httpStatusHandler : null;
  handlerArgs = typeof handlerArgs !== 'undefined' ? handlerArgs : null;
  this.loader = new org.apache.royale.net.URLLoader();
  this.loader.addEventListener(org.apache.royale.net.HTTPConstants.COMPLETE, function(e) {
    if (handlerArgs == null) {
      resultHandler(e);
    } else {
      resultHandler.apply(null, [e].concat(handlerArgs));
    }
  });
  if (faultHandler != null) {
    this.loader.addEventListener(org.apache.royale.net.HTTPConstants.IO_ERROR, function(e) {
      if (handlerArgs == null) {
        faultHandler(e);
      } else {
        faultHandler.apply(null, [e].concat(handlerArgs));
      }
    });
    this.loader.addEventListener(org.apache.royale.net.HTTPConstants.SECURITY_ERROR, function(e) {
      if (handlerArgs == null) {
        faultHandler(e);
      } else {
        faultHandler.apply(null, [e].concat(handlerArgs));
      }
    });
  }
  if (progressHandler != null) {
    this.loader.addEventListener(org.apache.royale.events.ProgressEvent.PROGRESS, function(e) {
      if (handlerArgs == null) {
        progressHandler(e);
      } else {
        progressHandler.apply(null, [e].concat(handlerArgs));
      }
    });
  }
  if (httpStatusHandler != null) {
    this.loader.addEventListener(org.apache.royale.net.HTTPConstants.STATUS, function(e) {
      if (handlerArgs == null) {
        httpStatusHandler(e);
      } else {
        httpStatusHandler.apply(null, [e].concat(handlerArgs));
      }
    });
  }
  this.loader.load(request);
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.crux.utils.services.CruxURLRequest', org.apache.royale.crux.utils.services.CruxURLRequest);


/**
 * @export
 * @type {org.apache.royale.net.URLLoader}
 */
org.apache.royale.crux.utils.services.CruxURLRequest.prototype.loader;


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.crux.utils.services.CruxURLRequest.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'CruxURLRequest', qName: 'org.apache.royale.crux.utils.services.CruxURLRequest', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.crux.utils.services.CruxURLRequest.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'loader': { type: 'org.apache.royale.net.URLLoader', get_set: function (/** org.apache.royale.crux.utils.services.CruxURLRequest */ inst, /** * */ v) {return v !== undefined ? inst.loader = v : inst.loader;}}
      };
    },
    accessors: function () {return {};},
    methods: function () {
      return {
        'CruxURLRequest': { type: '', declaredBy: 'org.apache.royale.crux.utils.services.CruxURLRequest', parameters: function () { return [ { index: 1, type: 'org.apache.royale.net.URLRequest', optional: false },{ index: 2, type: 'Function', optional: false },{ index: 3, type: 'Function', optional: true },{ index: 4, type: 'Function', optional: true },{ index: 5, type: 'Function', optional: true },{ index: 6, type: 'Array', optional: true } ]; }}
      };
    }
  };
};
/**
 * @export
 * @const
 * @type {number}
 */
org.apache.royale.crux.utils.services.CruxURLRequest.prototype.ROYALE_REFLECTION_INFO.compileFlags = 10;